﻿' Thanks to www.TheScarms.com for a piece of code that I used to get the list of file names in a directory.
' This program converts a folder containing 24 x 24 pixel graphics into constgraphicdata for swordfish basic.
' You need to open any one file in the folder and then specify how many files there are to be converted.
' then click the colors to convert (experiment a little with these for the best output) then click convert
' the program will output all data required and will copy it to the clipboard - you then paste it into swordfish basic

Imports Microsoft.VisualBasic.PowerPacks
Imports System.IO

Public Class Form1
    Dim RedData As String
    Dim GreenData As String
    Dim BlueData As String
    Dim OpenPictureFileName As String
    Dim DoConvertGraphic As Boolean = False
    Dim PictureWidth As Decimal
    Dim PictureHeight As Decimal
    Dim DataCounter As Decimal = 0
    Dim DataCounter2 As Decimal = 0
    Dim DirectoryName As String
    Dim Intensity As Byte = 128
    Dim NumberOfFrames As Decimal
    Dim NumberOfColorsToConvert As Decimal
    Dim ProgramMemorySize As Decimal = 0

    Dim PictureBoxLocation As New Point(0, 0)
    Dim PanelLocation As New Point(0, 0)
    Dim CursorLocation As New Point(0, 0)

    Dim PictureBoxClicked As Boolean = False
    Dim PanelClicked As Boolean = False

    Dim LoadedPictureWidth As Decimal
    Dim LoadedPictureHeight As Decimal

    Dim ZoomLevel As Decimal = 1
    Dim DataType As Decimal = 8 'our default is bytes (the other options are words 16 or longwords 32)

    Private Sub SetPositions()
        PictureBoxLocation = PictureBox1.Location
        PanelLocation = PanelConvertedGraphic.Location
        CursorLocation = System.Windows.Forms.Cursor.Position
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Timer1.Interval = "1"
        SetPositions()
        Intensity = 127 ' we need to start somewhere!
    End Sub

    Private Sub ConvertImage()
        Dim PaintColor As Color
        Dim TempBitmap As New Bitmap(PictureBox1.Image)
        Dim PixelColor As Color
        PictureWidth = (PictureBox1.Width - 1)  ' minus 1 because we start from the number 0 and not 1
        PictureHeight = (PictureBox1.Height - 1)
        For x = 0 To PictureHeight
            For y = 0 To PictureWidth
                PixelColor = TempBitmap.GetPixel(y, x)
                Dim s As String = PixelColor.ToString
                s = s.Trim("Color []".ToCharArray)
                Dim str() As String = s.Split(","c)
                RedData = str(1)
                GreenData = str(2)
                BlueData = str(3)
                RedData = RedData.Trim(" R=".ToCharArray)
                GreenData = GreenData.Trim(" G=".ToCharArray)
                BlueData = BlueData.Trim(" B=".ToCharArray)

                If RedData < Intensity And GreenData < Intensity And BlueData < Intensity Then
                    PaintColor = Color.Black
                ElseIf RedData < 128 And GreenData < 128 And BlueData > 127 Then
                    PaintColor = Color.Blue
                ElseIf RedData < 128 And GreenData > 127 And BlueData < 128 Then
                    PaintColor = Color.Green
                ElseIf RedData < 128 And GreenData > 127 And BlueData > 127 Then
                    PaintColor = Color.Cyan
                ElseIf RedData > 127 And GreenData < 128 And BlueData < 128 Then
                    PaintColor = Color.Red
                ElseIf RedData > 127 And GreenData < 128 And BlueData > 127 Then
                    PaintColor = Color.Magenta
                ElseIf RedData > 127 And GreenData > 127 And BlueData < 128 Then
                    PaintColor = Color.Orange
                ElseIf RedData > 127 And GreenData > 127 And BlueData > 127 Then
                    PaintColor = Color.White
                End If

                If CheckBoxInvertData.Checked Then  'invert the data so a logic 0 actually means the LED is on
                    If RedData > Intensity Then
                        TextBoxRed.AppendText(0)
                    ElseIf RedData < Intensity Then
                        TextBoxRed.AppendText(1)
                    End If
                    If GreenData > Intensity Then
                        TextBoxGreen.AppendText(0)
                    ElseIf GreenData < Intensity Then
                        TextBoxGreen.AppendText(1)
                    End If
                    If BlueData > Intensity Then
                        TextBoxBlue.AppendText(0)
                    ElseIf BlueData < Intensity Then
                        TextBoxBlue.AppendText(1)
                    End If
                Else                    ' don't invert the data :)
                    If RedData > Intensity Then
                        TextBoxRed.AppendText(1)
                    ElseIf RedData < Intensity Then
                        TextBoxRed.AppendText(0)
                    End If
                    If GreenData > Intensity Then
                        TextBoxGreen.AppendText(1)
                    ElseIf GreenData < Intensity Then
                        TextBoxGreen.AppendText(0)
                    End If
                    If BlueData > Intensity Then
                        TextBoxBlue.AppendText(1)
                    ElseIf BlueData < Intensity Then
                        TextBoxBlue.AppendText(0)
                    End If
                End If

                Using g As Graphics = PanelConvertedGraphic.CreateGraphics()
                    g.FillRectangle(New SolidBrush(PaintColor), y, x, 2, 2)
                    g.Dispose()
                End Using
                DataCounter += 1
                DataCounter2 += 1
                If RadioButtonSwordfish.Checked Then
                    If DataCounter = (DataType) And DataCounter2 <> (PictureBox1.Width * PictureBox1.Height) Then   'if the data type is bytes (8) then we will include a ,% every eight bits - words it would be every 16etc...
                        TextBoxRed.AppendText(", %")
                        TextBoxGreen.AppendText(", %")
                        TextBoxBlue.AppendText(", %")
                        DataCounter = 0
                    End If

                    If DataCounter2 = ((PictureBox1.Height) * (PictureBox1.Width)) Then
                        TextBoxRed.AppendText(")")
                        TextBoxGreen.AppendText(")")
                        TextBoxBlue.AppendText(")")
                    End If
                End If
                If RadioButtonArduino.Checked Then
                    If DataCounter = (DataType) And DataCounter2 <> (PictureBox1.Width * PictureBox1.Height) Then   'if the data type is bytes (8) then we will include a ,% every eight bits - words it would be every 16etc...
                        TextBoxRed.AppendText(", 0b")
                        TextBoxGreen.AppendText(", 0b")
                        TextBoxBlue.AppendText(", 0b")
                        DataCounter = 0
                    End If

                    If DataCounter2 = ((PictureBox1.Height) * (PictureBox1.Width)) Then
                        TextBoxRed.AppendText("};")
                        TextBoxGreen.AppendText("};")
                        TextBoxBlue.AppendText("};")
                    End If
                End If
            Next
        Next
    End Sub

    Private Sub CalculateFileSize()
        ProgramMemorySize = 0
        If OutputRed.Checked = True Then
            ProgramMemorySize = ProgramMemorySize + 1
        End If
        If OutputGreen.Checked = True Then
            ProgramMemorySize = ProgramMemorySize + 1
        End If
        If OutputBlue.Checked = True Then
            ProgramMemorySize = ProgramMemorySize + 1
        End If
        TextBoxProgramMemory.Text = ((ProgramMemorySize * PictureBox1.Height * PictureBox1.Width) / 8) & " Bytes"
    End Sub

    Private Sub DoConversion()
        TextBoxInfo.Text = "Converting Image"
        DataCounter = 0             ' clear the counters that we use when converting
        DataCounter2 = 0            ' clear the counters that we use when converting
        TextBoxRed.Clear()
        TextBoxGreen.Clear()
        TextBoxBlue.Clear()
        TextBoxAllData.Clear()
        Dim Directory As New IO.DirectoryInfo(DirectoryName)
        Dim Files As IO.FileInfo() = Directory.GetFiles("*.*")
        'Dim FileName As IO.FileInfo
        If RadioButtonArduino.Checked Then
            If RadioButtonLongWords.Checked Then
                TextBoxRed.AppendText("const prog_uint32_t " & TextBoxOutputName.Text & "Red" & "[" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & "]PROGMEM={0b")
                TextBoxGreen.AppendText("const prog_uint32_t " & TextBoxOutputName.Text & "Green" & "[" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & "]PROGMEM={0b")
                TextBoxBlue.AppendText("const prog_uint32_t " & TextBoxOutputName.Text & "Blue" & "[" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & "]PROGMEM={0b")
            ElseIf RadioButtonWords.Checked Then
                TextBoxRed.AppendText("const prog_uint16_t " & TextBoxOutputName.Text & "Red" & "[" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & "]PROGMEM={0b")
                TextBoxGreen.AppendText("const prog_uint16_t " & TextBoxOutputName.Text & "Green" & "[" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & "]PROGMEM={0b")
                TextBoxBlue.AppendText("const prog_uint16_t " & TextBoxOutputName.Text & "Blue" & "[" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & "]PROGMEM={0b")
            ElseIf RadioButtonBytes.Checked Then
                TextBoxRed.AppendText("const prog_uint8_t " & TextBoxOutputName.Text & "Red" & "[" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & "]PROGMEM={0b")
                TextBoxGreen.AppendText("const prog_uint8_t " & TextBoxOutputName.Text & "Green" & "[" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & "]PROGMEM={0b")
                TextBoxBlue.AppendText("const prog_uint8_t " & TextBoxOutputName.Text & "Blue" & "[" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & "]PROGMEM={0b")
            End If
        End If
        If RadioButtonSwordfish.Checked Then
            If RadioButtonLongWords.Checked Then
                TextBoxRed.AppendText("const " & TextBoxOutputName.Text & "Red" & "(" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & ") as longword = (%")
                TextBoxGreen.AppendText("const " & TextBoxOutputName.Text & "Green" & "(" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & ") as longword = (%")
                TextBoxBlue.AppendText("const " & TextBoxOutputName.Text & "Blue" & "(" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & ") as longword = (%")
            ElseIf RadioButtonWords.Checked Then
                TextBoxRed.AppendText("const " & TextBoxOutputName.Text & "Red" & "(" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & ") as word = (%")
                TextBoxGreen.AppendText("const " & TextBoxOutputName.Text & "Green" & "(" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & ") as word = (%")
                TextBoxBlue.AppendText("const " & TextBoxOutputName.Text & "Blue" & "(" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & ") as word = (%")
            ElseIf RadioButtonBytes.Checked Then
                TextBoxRed.AppendText("const " & TextBoxOutputName.Text & "Red" & "(" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & ") as byte = (%")
                TextBoxGreen.AppendText("const " & TextBoxOutputName.Text & "Green" & "(" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & ") as byte = (%")
                TextBoxBlue.AppendText("const " & TextBoxOutputName.Text & "Blue" & "(" & (PictureBox1.Height * (PictureBox1.Width / DataType)) & ") as byte = (%")
            End If
        End If
        ConvertImage()
        If OutputRed.Checked = True Then
            TextBoxAllData.AppendText(TextBoxRed.Text & vbCrLf)
        End If
        If OutputGreen.Checked = True Then
            TextBoxAllData.AppendText(TextBoxGreen.Text & vbCrLf)
        End If
        If OutputBlue.Checked = True Then
            TextBoxAllData.AppendText(TextBoxBlue.Text)
        End If
        TextBoxAllData.SelectAll()
        TextBoxAllData.Copy()
        TextBoxInfo.Text = "Data Copied To Clipboard"
        MsgBox("Data Has Been Copied To The Clipboard")
    End Sub


    Private Sub ButtonConvert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonConvert.Click
        DoConversion()
    End Sub

    Private Sub ButtonQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Close()
    End Sub

    Private Sub OutputRed_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OutputRed.CheckedChanged
        CalculateFileSize()
    End Sub

    Private Sub OutputGreen_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OutputGreen.CheckedChanged
        CalculateFileSize()
    End Sub

    Private Sub OutputBlue_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OutputBlue.CheckedChanged
        CalculateFileSize()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If PictureBoxClicked = True Then
            PictureBox1.Location = PictureBoxLocation - CursorLocation + System.Windows.Forms.Cursor.Position
        End If
        SetPositions()
    End Sub

    Private Sub PanelConvertedGraphic_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        PanelClicked = True
        Timer1.Enabled = True
        Timer1.Start()
        SetPositions()
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        PictureBoxClicked = True
        Timer1.Enabled = True
        Timer1.Start()
        SetPositions()
    End Sub

    Private Sub PictureBox1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseUp
        PictureBoxClicked = False
        Timer1.Stop()
        SetPositions()
    End Sub

    Private Sub QuitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles QuitToolStripMenuItem.Click
        Close()
    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Try
            TextBoxInfo.Text = "Loading Image"
            OpenFilePictureBox1.InitialDirectory = "C:\"
            OpenFilePictureBox1.Title = "Open an Image"
            OpenFilePictureBox1.Filter = "PNG Files (.png)|*.png|JPG Files (.jpg)|*.jpg|BMP Files (.bmp)|*.bmp"
            OpenFilePictureBox1.ShowDialog()
            OpenPictureFileName = OpenFilePictureBox1.FileName
            PictureBox1.Image = Image.FromFile(OpenPictureFileName)
            DirectoryName = Path.GetDirectoryName(OpenPictureFileName) & "\"
            ButtonConvert.Enabled = True
            TextBoxWidth.Text = PictureBox1.Width
            TextBoxHeight.Text = PictureBox1.Height
            LoadedPictureWidth = PictureBox1.Width
            LoadedPictureHeight = PictureBox1.Height
            PanelConvertedGraphic.Height = PictureBox1.Height
            PanelConvertedGraphic.Width = PictureBox1.Width
            ButtonZoomIn.Enabled = True
            TextBoxInfo.Text = "Image Successfully Loaded"
            RadioButtonArduino.Enabled = True
            RadioButtonBytes.Enabled = True
            RadioButtonLeftToRight.Enabled = True
            RadioButtonLongWords.Enabled = True
            RadioButtonSwordfish.Enabled = True
            RadioButtonTopToBottom.Enabled = True
            RadioButtonWords.Enabled = True
            OutputRed.Enabled = True
            OutputGreen.Enabled = True
            OutputBlue.Enabled = True
            CheckBoxInvertData.Enabled = True
            NumericUpDownColorAdjust.Enabled = True
            CalculateFileSize()
        Catch ex As Exception
            ' Do nothing if a file isn't opened.
        End Try
        'TextBox4.AppendText(System.IO.Directory.GetFiles(DirectoryName).Length()) this gets the number of files in the folder but also includes thumbnails.db when it has one, so this doesnt work.
    End Sub

    Private Sub HelpToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HelpToolStripMenuItem1.Click
        MsgBox("Arduino and Swordfish Graphic Converter By Brad Slattery 2012" & vbCrLf & vbCrLf & _
        "Your Image Width Must Be Divisible By 8, 16 or 32." & vbCrLf & vbCrLf & vbCrLf & _
        "- God is the original developer, I'm just following in His footsteps -")
    End Sub

    Private Sub ButtonZoomIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonZoomIn.Click
        If ButtonZoomOut.Enabled = False Then
            ButtonZoomOut.Enabled = True
        End If
        ZoomLevel = ZoomLevel + 1
        If ZoomLevel = 10 Then
            ButtonZoomIn.Enabled = False
        End If
        TextBoxInfo.Text = "Zoom Level  " & (ZoomLevel * 100) & "%"
    End Sub

    Private Sub ButtonZoomOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonZoomOut.Click
        If ButtonZoomIn.Enabled = False Then
            ButtonZoomIn.Enabled = True
        End If
        ZoomLevel = ZoomLevel - 1
        If ZoomLevel = 1 Then
            ButtonZoomOut.Enabled = False
        End If
        TextBoxInfo.Text = "Zoom Level  " & (ZoomLevel * 100) & "%"
    End Sub

    Private Sub RadioButtonBytes_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonBytes.CheckedChanged
        If RadioButtonBytes.Checked Then
            DataType = 8
        ElseIf RadioButtonWords.Checked Then
            DataType = 16
        ElseIf RadioButtonLongWords.Checked Then
            DataType = 32
        End If
    End Sub

    Private Sub RadioButtonWords_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonWords.CheckedChanged
        If RadioButtonBytes.Checked Then
            DataType = 8
        ElseIf RadioButtonWords.Checked Then
            DataType = 16
        ElseIf RadioButtonLongWords.Checked Then
            DataType = 32
        End If
    End Sub

    Private Sub RadioButtonLongWords_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonLongWords.CheckedChanged
        If RadioButtonBytes.Checked Then
            DataType = 8
        ElseIf RadioButtonWords.Checked Then
            DataType = 16
        ElseIf RadioButtonLongWords.Checked Then
            DataType = 32
        End If
    End Sub

    Private Sub RadioButtonSwordfish_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonSwordfish.CheckedChanged
        If RadioButtonArduino.Checked Then
            RadioButtonBytes.Text = "prog_uint8_t"
            RadioButtonWords.Text = "prog_uint16_t"
            RadioButtonLongWords.Text = "prog_uint32_t"
        Else
            RadioButtonBytes.Text = "Bytes"
            RadioButtonWords.Text = "Words"
            RadioButtonLongWords.Text = "Longwords"
        End If
    End Sub

    Private Sub RadioButtonArduino_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonArduino.CheckedChanged

    End Sub

    Private Sub ConvertToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConvertToolStripMenuItem.Click
        DoConversion()
    End Sub

    Private Sub NumericUpDownColorAdjust_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownColorAdjust.ValueChanged
        Intensity = (NumericUpDownColorAdjust.Value / 100) * 255    ' get the percentage of the max number we can have for the intensity
        'DoConversion()
    End Sub
End Class
